module Patch (patchToks, pprPatchWarn) where

import Format
import Types
import Merge
import qualified Data.ByteString as B

data PatchWarn = HunkMatched Hunk Int | HunkFailed Hunk

pprPatchWarn :: PatchWarn -> String
pprPatchWarn (HunkMatched ((o,n), _) at) = "hunk (-"++ show o ++ " +"++show n++") succeeded at "++show at
pprPatchWarn (HunkFailed ((o,n),_)) = "hunk (-"++ show o ++ " +"++show n++") FAILED"

patchToks :: TV -> [Hunk] -> Bool -> MergeOpts -> (TV, [Hunk], [PatchWarn])
patchToks toks hunks rev mopt = undefined
  --let (tokss, hunk, sus) = patchHunksAt 0 0 0 (if rev then map revHunk hunks else hunks) mopt
  

patchHunksAt :: TV -> Int -> Int -> Int -> [Hunk] -> MergeOpts -> ([TV], [PatchWarn])
patchHunksAt toks tvoff origoff newoff hunks mopt = undefined

hunkToMatch :: Diff -> Diff
hunkToMatch = filter $ (`elem` [Keep, Remove, Original]) . fst

hunkToReplace :: Diff -> Diff
hunkToReplace = filter $ (`elem` [Keep, Add, MineChanged, YourChanged]) . fst

tokCmp :: Bool -> Tok -> Tok -> Bool
tokCmp True (False, _) (False, _) = True -- ignore the whitespace change
tokCmp _ a b = a == b -- otherwise just compare
